/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   globalFunc.h
 * Author: sjg
 *
 * Created on 2016年11月7日, 下午5:24
 */

#ifndef GLOBALFUNC_H
#define GLOBALFUNC_H
#include <fstream>
#include <iostream>
#include <sys/stat.h>
#include <sys/types.h>
#include<cstdlib>
#include<unistd.h>
//#include <linux/kernel.h>
//#include <linux/unistd.h>
#include<sys/wait.h>
//#include<sys/sysinfo.h>
#include <unistd.h>
#include <errno.h>
#include <dirent.h>
#include <ctime>
#include<cstring>
#include<vector>
#include<set>
#include<map>
#include<assert.h>
#include <algorithm>
#include "dataTypeDef.h"
using namespace std;
typedef struct addLiteralEquality{
    string literal;
    int suffix;
}literalAdd;
typedef struct addfuncEquality{
    string func;
    int suffix;
}funcAdd;
//去除字符前后空格
inline void TrimStr(string& s)
{
    if (s.empty())
        return;
    s.erase(0, s.find_first_not_of(" "));
    s.erase(s.find_last_not_of(" ") + 1);
}
inline UINT32 BKDRHash(UINT32 hash, int termCode) {
    //UINT32 seed=31;
    /*UINT32 hash=0;*/
    //termCode=termCode&0x7FFFFFFF; //转换为正数
    hash = hash * 31 + termCode;
    return hash & 0x7FFFFFFF; //转换为正数
}

//查找子字符串
inline int FindSubStr(string& str, string& subStr)
{
    int pos = -1;
    size_t strLen = str.size(), subStrLen = subStr.size();
    if (strLen < subStrLen)
        return -1;
    while (pos++<strLen) {
        bool flag = false;
        if (str[pos] == subStr[0]) {
            flag = true;
            for (size_t k = 1; k < subStrLen; k++) {
                if (str[pos + k] != subStr[k]) {
                    flag = false;
                    break;
                }
            }
        }
        if (flag && (str[pos + subStrLen] == ')' || str[pos + subStrLen] == ',')) {
            return pos;
        }
    }
    return -1;
}
//分割字符串
inline vector<string> Split_c(const string& s, const char delim)
{
    size_t last = 0;
    size_t index = s.find_first_of(delim, last);
    vector<string> ret;
    while (index != string::npos) {
        ret.push_back(s.substr(last, index - last));
        last = index + 1;
        index = s.find_first_of(delim, last);
    }
    if (index - last > 0)
        ret.push_back(s.substr(last, index - last));
    return ret;
}
//分割字符串 
inline vector<string> Split_s(const string& s, const string& delim)
{
    size_t last = 0;
    size_t index = s.find_first_of(delim, last);
    vector<string> ret;
    while (index != string::npos) {
        ret.push_back(s.substr(last, index - last));
        last = index + 1;
        index = s.find_first_of(delim, last);
    }
    if (index - last > 0)
        ret.push_back(s.substr(last, index - last));
    return ret;
}

//返回谓词符号以及第一个括号所在位置
inline string GetPred(const string& pred, size_t& i)
{
    size_t predSize = pred.size();
    assert(predSize != 0);
    //if(predSize==0)return nullptr;		
    i = pred.find_first_of('(');
    assert(i != 0);
    assert(i != string::npos);
    return pred.substr(0, i);
}

//分离谓词符号和括号中内容
inline void SplitSymbol(const string &pred, string &symbol, string &strContent)
{
    size_t pos = 0;
    symbol = GetPred(pred, pos);
    strContent = pred.substr(pos + 1, pred.length() - pos - 2); //抽取内容
}
//判定是否为基文字-是否包含'x'
inline bool IsBaseLits(vector<string>& vectStrLits)
{
    bool isBase = true;
    for (int i = 0; i < vectStrLits.size(); i++) {
        string str = vectStrLits[i];
        if (str.find('x') != string::npos) {
            isBase = false;
            break;
        }
    }
    return isBase;
}
inline void stringAddOne(string & str)
{
    for(int i=0; i<str.length(); ++i){
        str.at(i) = str.at(i) +1;
    }
}


inline void stringPlusOne(string & str)
{
    for(int i=0; i<str.length(); ++i){
        str.at(i) = str.at(i) - 1;
    }
}

#endif /* GLOBALFUNC_H */

