/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mcs_scs;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;

/**
 *
 * @author ars01
 */
public class Mcs_scs {
    /**
     * special number members
     */
    static String proverName = "cse";
    static String paraProverName = "";
    static String timeSet = "";
    static String problemFileName = "";
    static String problemPath = "";
    static String workPath = "";
    //static String convertProblemPath = "";
    //static String proofProblemPath = "";
    static int problemFormat = 0;//0:fof; 1:cnf
    static int strategyMode = 0;//0: single; 1:multi and combined; 2:multi and independent
    static int runMode = 0; //0: proof single problem; 1:proof batch problems
    static int versionMode = 1;//0:inner version; 1:competition version
    
    //20190711
    static int cseInferenceRule = 2;//0: optimal; 1: fullUseClause; 2: optimal&fullUseClause; 3: fullUseClause&optimal
    static double distributedFirstTime;// if 2 or 3, the time distribution
    static boolean equalityFlag = false;
    
    static int totalRunTime = 300;
    /**
     * @ return tool path
     */
    static private String getAppPath() {
        ClassLoader loader = Mcs_scs.class.getClassLoader();
        String clsName = Mcs_scs.class.getName() + ".class";
        Package pack = Mcs_scs.class.getPackage();
        String path = "";
        if(pack != null){
            String packName = pack.getName();
            clsName = clsName.substring(packName.length()+1);
            if(packName.indexOf(".")<0){
                path = packName + "/";
            }
            else{
                int start =0,end =0;
                end =packName.indexOf(".");
                while(end != -1){
                    path = path + packName.substring(start, end) + "/";
                    start = end +1;
                    end = packName.indexOf(".",start);
                }
                path = path + packName.substring(start) + "/";
            }
        }
        
        String realPath ;
        realPath = Mcs_scs.class.getClassLoader().getResource(path + clsName).getPath();
        int pos = realPath.indexOf("file:");
        if(pos > -1) 
            realPath = realPath.substring(pos + 5);
        pos = realPath.indexOf(path + clsName);
        realPath = realPath.substring(0,pos -1 );
        if(realPath.endsWith("!"))
            realPath = realPath.substring(0, realPath.lastIndexOf("/"));
        try {
            realPath = java.net.URLDecoder.decode(realPath, "UTF-8");//转换中文及空格
        } catch (Exception e) {
            return "";
        }
        return realPath;
    }
    /**
     * @ creatFile
     */ 
    private void createDir(String dirName)
    {
        File dir = new File(dirName);
        if(dir.exists()){
            
            return; 
        }
        dir.mkdirs();
    }
    /**
     * @ creatFile, if filePath is existed, need be cleaned
     */
    static private void CreateDirButDel(String dirName){
        File file = new File(dirName);
        if (!file.exists() || !file.isDirectory()) {
            file.mkdir();
        }
        else{//清空记录
            File[] files = file.listFiles();
            for (int i = 0; i < files.length; i++) {
                File tmp = files[i];
                if (tmp.isDirectory()) {
                    deleteDir(tmp);
                }
                else
                    tmp.delete();
            }
        }
    }
    /**
     * @ delete filePath
     */
    static private void deleteDir(File dir){
        if(dir.isDirectory()){
            String[] children = dir.list();
            for(int i=0; i<children.length; ++i){
                deleteDir(new File(dir,children[i]));
            }
        }
        dir.delete();
    }
    /**
     * @open a directory, return fileList
     */
    static private File[] getProblemDirectory(String problemDirectory) {
        File dirs[] = null;
        dirs = new File(problemDirectory).listFiles();//列出求解器输出目录下所有目录
        return dirs;
    }
    /**
     * @read fof file and whether has added equality
     */
    
    static public void readFofFile(String outFileName){
        try {
            String sourceLine;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(outFileName), "UTF8"));
            while ((sourceLine = br.readLine()) != null) {
                if(sourceLine.contains("=")){
                    equalityFlag = true;
                    break;
                }
            }
            br.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    /**
     * @param add context to file 
     */
    static private void insertContext(String context, String filePath) {
        FileWriter fw = null;
        try {
            fw = new FileWriter(filePath, true);
            fw.write(context + "\n");
            fw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        //command:java Mcs_scs problemPath problemFormat runMode, problemPath need place tool path
        //problem path
        //System.out.println("args[0]:"+args[0]+";"+"args[1]:"+args[1]+";"+"args[2]:"+args[2]+";"+"args[3]:"+args[3]+";"+"args[4]:"+args[4]+";");
        boolean debugStatExec = false;
        boolean submit = true;
        if(submit){
            timeSet = args[0];
            problemFileName = args[1];
            totalRunTime = Integer.parseInt(timeSet);
            //System.out.println("run toal time:" + timeSet);s
            if(timeSet.equals("120")){
                distributedFirstTime = 120 - 15;
            }
            else if(timeSet.equals("150")){
                distributedFirstTime = 150 - 18;
            }
            else if(timeSet.equals("180")){
                distributedFirstTime = 180 - 22;
            }
            else if(timeSet.equals("210")){
                distributedFirstTime = 210 - 26;
            }
            else if(timeSet.equals("240")){
                distributedFirstTime = 240 - 30;
            }
            else if(timeSet.equals("270")){
                distributedFirstTime = 270 - 33;
            }
            else if(timeSet.equals("300")){
                distributedFirstTime = 300 - 37;
            }
            else if(timeSet.equals("330")){
                distributedFirstTime = 330 - 41;
            }
            else if(timeSet.equals("360")){
                distributedFirstTime = 360 - 44;
            }
            else{
                distributedFirstTime = totalRunTime * 0.877;
            }
        }
        else{
            paraProverName = args[0];
            problemFileName = args[1]; 
        }
        
        //System.out.println("TMO-Non");
        
        boolean fileParam = false;
        if(((new File(problemFileName)).exists()) && ((new File(problemFileName)).isDirectory())){
            problemPath = problemFileName;
        }
        else if(((new File(problemFileName)).exists()) && !((new File(problemFileName)).isDirectory())){
            problemPath = problemFileName;
            fileParam = true;
        }
        else if(problemFileName.contains(File.separator)){
            problemFileName = problemFileName.substring(0, problemFileName.lastIndexOf(File.separator));
            problemPath = getAppPath() + File.separator + problemFileName;
        }
        else{
            problemPath = getAppPath() + File.separator + problemFileName;
        }
        //System.out.println("java->timeLimit:" + timeSet + "; problem:" +problemFileName);
        workPath = getAppPath() + File.separator + "output";
        CreateDirButDel(workPath);
        //System.out.println("creat workPath:" + workPath);
        if(!submit){
            String resultFilePath = getAppPath() + File.separator + "/proofStatistics.txt";
            File statisticFile = new File(resultFilePath);
            if(statisticFile.exists()){
                statisticFile.delete();
            }
        }
        //convert problem path
//        convertProblemPath = getAppPath() + File.separator + "convertFile";
//        CreateDirButDel(convertProblemPath);
        //proof problem path
//        proofProblemPath = getAppPath() + File.separator + "proofFile";
//        CreateDirButDel(proofProblemPath);
        //problem format
        
        if(submit){
            problemFormat = 0;//Integer.parseInt(args[2]);//format fof:0; format fof:1
            //strategy mode
            strategyMode = 1;//Integer.parseInt(args[3]);//single strategy:0 ; a lot of strategies:1;
            //runMode
            runMode = 0;//Integer.parseInt(args[4]);
            //version division
            versionMode = 1;//Integer.parseInt(args[5]);
            cseInferenceRule = 3;
            //distributedFirstTime = 100;
        }
        else{
            problemFormat = Integer.parseInt(args[2]);
            //strategy mode
            strategyMode = Integer.parseInt(args[3]);
            //runMode
            runMode = Integer.parseInt(args[4]);
            //version division
            versionMode = Integer.parseInt(args[5]);
            //0: optimal; 1: fullUseClause; 2: optimal&fullUseClause; 3: fullUseClause&optimal
            cseInferenceRule  = Integer.parseInt(args[6]);
            // if 2 or 3, the time distribution
            distributedFirstTime = Double.parseDouble(args[7]);
            
            //add random runTotalTime
            totalRunTime = Integer.parseInt(args[8]);
        }
        
        if(runMode == 0){//single runMode
            if(fileParam){
                //证明器名称 问题 问题格式 策略模式 运行模式 版本说明
                String problemName = problemPath.substring(problemPath.lastIndexOf(File.separator) + 1);
                String problemNameNoSuffix = problemName.substring(0, problemName.lastIndexOf("."));
                String problemFile = workPath + File.separator + problemNameNoSuffix;
                
                if(debugStatExec){
                    System.out.println("start to run CSE prover");
                }
                
                String runCmd = "timeout " + totalRunTime + " " + getAppPath() + File.separator + proverName + " " + problemPath + " " + problemFormat + " " + strategyMode + " " + runMode + " " + versionMode + " " + getAppPath() + " " + (totalRunTime - 1) + " " + cseInferenceRule + " " + distributedFirstTime;
                
                String[] cmdProc = {"/bin/sh", "-c", runCmd};                
                try {
                    Process pro = Runtime.getRuntime().exec(cmdProc);
                    BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                    String linePro = "";
                    boolean oneTime = true;
                    boolean outFlag = false;
                    while ((linePro = bufferedReaderPro.readLine()) != null) {
                        if ((linePro.contains("output start Proof")) && oneTime ) {
                            outFlag = true;
                            oneTime = false;
                        }
                        
                        System.out.println(linePro);
                    }
                    pro.waitFor();
                    bufferedReaderPro.close();
                    
                    if(!outFlag){                        
                        
                        equalityFlag = false;
                        //find cnf file
                        String cnfFilePathF = workPath + File.separator + "tptp";
                        File tptpFile = new File(cnfFilePathF);
                        if (tptpFile.exists()) {
                            File filesFind[] = tptpFile.listFiles();
                            for (int m = 0; m < filesFind.length; ++m) {
                                String name = filesFind[m].getName();
                                String postFix = name.substring(name.lastIndexOf(".") + 1);
                                if (postFix.endsWith("tptp") == false) {
                                    continue;
                                }
                                String nameFof = " ";
                                if(name.contains("+"))
                                    nameFof = name.substring(0, name.lastIndexOf("+"));
                                if(nameFof.contains("+"))
                                    nameFof = nameFof.substring(0, nameFof.lastIndexOf("+"));
                                if (nameFof.equals(problemNameNoSuffix)) {
                                    problemNameNoSuffix = name.substring(0, name.lastIndexOf("."));
                                    break;
                                }
                            }
                        }
                        
//                        readFofFile(problemPath);
//                        if (equalityFlag) {
//                            problemNameNoSuffix += "+short+eq_rstfp";
//                        } else {
//                            problemNameNoSuffix += "+short+noeq";
//                        }
                        problemFile = workPath + File.separator + problemNameNoSuffix;
                        File file = new File(problemFile);
                        if(file.exists()){
                            deleteDir(file);
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            else{
                File files[] = (new File(problemPath)).listFiles();
                if ((files == null) || (files.length == 0)) {
                    System.out.println("proof file is empty!");
                } else {
                    for (int i = 0; i < files.length; ++i) {
                        if (files[i].isDirectory()) {
                            continue;
                        } else {
                            //证明器名称 问题 问题格式 策略模式 运行模式 版本说明
                            String problemName = files[i].getAbsolutePath();
                            problemName = problemName.substring(problemName.lastIndexOf(File.separator) + 1);
                            String problemNameNoSuffix = problemName.substring(0, problemName.lastIndexOf("."));
                            String problemFile = workPath + File.separator + problemNameNoSuffix;
                            String runCmd = "timeout " + totalRunTime + " " + getAppPath() + File.separator + proverName + " " + files[i].getAbsolutePath() + " " + problemFormat + " " + strategyMode + " " + runMode + " " + versionMode + " " + getAppPath() + " " + (totalRunTime-1) + " " + cseInferenceRule + " " + distributedFirstTime;
                            //System.out.println(runCmd);
                            String[] cmdProc = {"/bin/sh", "-c", runCmd};
                            
                            try {
                                Process pro = Runtime.getRuntime().exec(cmdProc);
                                BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                                String linePro = "";
                                boolean oneTime = true;
                                boolean outFlag = false;
                                while ((linePro = bufferedReaderPro.readLine()) != null) {
                                    if ((linePro.contains("output start Proof")) && oneTime) {
                                        outFlag = true;
                                        oneTime = false;
                                    }
                                    
                                    System.out.println(linePro);
                                }
                                pro.waitFor();
                                bufferedReaderPro.close();
                                if (!outFlag) {                                            
                                    equalityFlag = false;
                                    //find cnf file
                                    String cnfFilePathF = workPath + File.separator + "tptp";
                                    File tptpFile = new File(cnfFilePathF);
                                    if (tptpFile.exists()) {
                                        File filesFind[] = tptpFile.listFiles();
                                        for (int m = 0; m < filesFind.length; ++m) {
                                            String name = filesFind[m].getName();
                                            String postFix = name.substring(name.lastIndexOf(".") + 1);
                                            if (postFix.endsWith("tptp") == false) {
                                                continue;
                                            }
                                            String nameFof = " ";
                                            if(name.contains("+"))
                                                nameFof = name.substring(0, name.lastIndexOf("+"));
                                            if(nameFof.contains("+")) {
                                                nameFof = nameFof.substring(0, nameFof.lastIndexOf("+"));
                                            }
                                            if(nameFof.equals(problemNameNoSuffix)) {
                                                problemNameNoSuffix = name.substring(0, name.lastIndexOf("."));
                                                break;
                                            }
                                        }
                                    }
                                    
//                                    readFofFile(files[i].getAbsolutePath());
//                                    if (equalityFlag) {
//                                        problemNameNoSuffix += "+short+eq_rstfp";
//                                    } else {
//                                        problemNameNoSuffix += "+short+noeq";
//                                    }
                                    problemFile = workPath + File.separator + problemNameNoSuffix;
                                    File file = new File(problemFile);
                                    if(file.exists()) {
                                        deleteDir(file);
                                    }
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    }
                }
            }
            
        }
        else if (runMode == 1) {
            String runCmd = "timeout " + totalRunTime + " " + getAppPath() + File.separator + proverName + " " + problemPath + " " + problemFormat + " " + strategyMode + " " + runMode + " " + versionMode + " " + getAppPath()+ " " + (totalRunTime-1) + " " + cseInferenceRule + " " + distributedFirstTime;
            //System.out.println(runCmd);
            String[] cmdProc = {"/bin/sh", "-c", runCmd};
            try {
                Process pro = Runtime.getRuntime().exec(cmdProc);
                BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                String linePro = "";
                while ((linePro = bufferedReaderPro.readLine()) != null) {
                    System.out.println(linePro);
                }
                pro.waitFor();
                bufferedReaderPro.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        //read result
        if(!submit) {
            String resultFilePath = getAppPath() + File.separator + "/proofStatistics.txt";
            if ((new File(resultFilePath)).exists()) {
                try {
                    String sourceLine = "";
                    int convertFail = 0;
                    int timeOut = 0;
                    int proofAll = 0;
                    int solveNumber = 0;
                    BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(resultFilePath), "UTF8"));
                    while ((sourceLine = br.readLine()) != null) {
                        if (sourceLine.contains("TMO‑Non")) {
                            ++timeOut;
                        } else if (sourceLine.contains("UNK‑Non")) {
                            ++convertFail;
                        }
                        ++proofAll;
                    }
                    br.close();
                    solveNumber = proofAll - timeOut - convertFail;
                    System.out.println("total numbers:" + proofAll + "  solver numbers:" + solveNumber + "   timeout numbers:" + timeOut + "   convertFailNumbers:" + convertFail);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }
    
}
