/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   StrategyParam.h
 * Author: sjg
 *
 * Created on 2016年11月18日, 下午7:54
 */

#ifndef STRATEGYPARAM_H
#define STRATEGYPARAM_H
#include "../basic/dataTypeDef.h"
#include "../basic/globalFunc.h"
class StrategyParam {
public:
    StrategyParam();
    StrategyParam(const StrategyParam& orig);
    virtual ~StrategyParam();
    static UINT32 g_RUNTIMES; //总迭代次数		 		
    //逆向演绎时传入的 全局ID 
    static string g_GobalID;
    //原始子句信息
    static UINT32 orginalClaNum;
    static UINT32 g_ClaNumNoAxiom; //原始子句个数（不包含等词）
    static UINT32 g_AxiomNum; //等词个数
    static bool problemDifficult;
    //static string g_PreproceFilePath;//预处理文件存放完整路径
    //全局运行策略
    static INT32 R_MAX_TERMNUM; //文字中最大项个数
    
    static INT32 SORT_STRATEGY_ALL; //全局排序策略
    static INT32 WORD_NUM_TYPE; //子句文字数策略
    static INT32 WEIGHT_TYPE; //权重设置
    static INT32 STEADY_TYPE; //稳定度算法
    static INT32 SORT_STRATEGY_WORD; //文字排序策略
    static INT32 START_STRATEGY_OTHERTRI; //其余三角形起步策略
    static INT32 SORT_STRATEGY_UNUSECLAUSE; //未归结子句排序策略
    static INT32 SPLIT_FILE_NUM; //分解S限制，剩余文字个数上限
    static INT32 FEATURE_START_CLA; //起步子句特征 -1无，0按最多文字数<=
    static INT32 NUM_LIT_STARTCLA; //起步子句特征【0】--最多文字数
    static bool ISRESTRICT; //是否放开谓词约束
    static bool ISBACk_FIRST_TRI; //是否回溯第一个△路径
    static bool ISREVERSE_DEDUCT_S; //是否进行逆向演绎分解S
    //新的启发式策略
    static INT32 SEL_STARTLit_STRATEGY; //起步文字选择策略
    static INT32 SEL_STARTLIT_NUMLIT; //起步文字文字数策略
    static INT32 SEL_STARTLIT_STEADY; //起步文字稳定度策略
    static bool SEL_STARTLIT_R; //起步策略--归结式起步
    static INT32 SEL_ACTLIT_STRATEGY; //主动归结文字选择策略
    static INT32 SEL_ACTLIT_STEADY; //主动归结文字文字数策略
    static INT32 SEL_POSLIT_STRATEGY; //被动归结文字选择策略
    static INT32 SEL_POSLIT_NUMLIT; //被动归结文字文字数策略
    static INT32 SEL_POSLIT_STEADY; //被动归结文字文字数策略

    static set<UINT32> CORE_CLAID_SET; //核心子句集
    static UINT32 g_IterTimes; //强行迭代轮数

    static UINT32 g_IterTimesX; //X轮数后 R文字个数限制进行改变 默认为0 则不改变
    static int g_RChgNum; //R文字个数改变 负数减少 正数增加 默认为0
    //20170220 定义策略静态变量
    //单元子句选取策略
    static INT32  unitChoose;  //单元子句选取策略
    //0:归结次数>冗余次数>稳定度>函数嵌套层 1:冗余次数>归结次数>稳定度>函数嵌套层 2:归结次数>冗余次数>函数嵌套层>稳定度
    //3:冗余次数>归结次数>函数嵌套层>稳定度 4:无(由原始顺序为准)
    static INT32  unitDeduct;  //单元子句归结次数策略
    //0:由低到高 1:无(由输入顺序为准)  2:由高到低
    static INT32  unitRedunt;  //单元子句冗余次数策略
    //0:由低到高 1:无(由输入顺序为准) 2:由高到低
    static INT32  unitSteady;  //单元子句稳定度策略
    //0:由高到低 1:无(由原始顺序为准) 2:由低到高
    static INT32  unitFuncLayer;  //单元子句函数嵌套层策略
    //0:由高到低 1:无(由输入顺序为准) 2:由低到高
    //候选子句选取策略
    static INT32  candChoose;  //候选子句选取策略
    //0:归结次数>冗余次数>文字数>稳定度 1:冗余次数>归结次数>文字数>稳定度 2:归结次数>冗余次数>稳定度>文字数
    //3:冗余次数>归结次数>稳定度>文字数 4:无(由原始顺序为准)
    static INT32  candDeduct;  //候选子句归结次数策略
    //0:由低到高 1:无(由输入顺序为准) 2:由高到低
    static INT32  candRedunt;  //候选子句冗余次数策略
    //0:由低到高 1:无(由输入顺序为准) 2:由高到低
    static INT32  candClause;  //候选子句文字数策略
    //0:由小到大 1:无(由输入顺序为准) 2:由大到小
    static INT32  candSteady;  //候选子句稳定度策略
    //0:由高到低 1:无(由原始顺序为准) 2:由低到高
    //单元子句归结次数最大值策略
    static INT32  unitDeductTimes;  //单元子句归结次数最大值策略
    //为-1时，系统自动处理；为大于0时设置值有效；
    static INT32  unitDeductTimesUpdate;  //单元子句归结次数更新策略
    //0:系统自动处理 1:迭代1次更新 2:迭代完成更新
    //3:轮数1次更新 4:轮数完成更新
    static INT32  unitReduntTimes;  //单元子句冗余次数最大值策略
    //为-1时，系统自动处理；为大于0时设置值有效； 
    static INT32  unitReduntTimesUpdate;  //单元子句冗余次数更新策略
    //0:系统自动处理 1:迭代1次更新 2:迭代完成更新
    //3:轮数1次更新 4:轮数完成更新
    //候选子句归结次数最大值策略
    static INT32  candDeductTimes;  //候选子句归结次数最大值策略
    //为-1时，系统自动处理；为大于0时设置值有效；
    static INT32  candDeductTimesUpdate;  //候选子句归结次数更新策略
    //0:系统自动处理 1:迭代1次更新 2:迭代完成更新
    //3:轮数1次更新 4:轮数完成更新
    static INT32  candReduntTimes;  //候选子句冗余次数最大值策略
    //为-1时，系统自动处理；为大于0时设置值有效；
    static INT32  candReduntTimesUpdate;  //候选子句冗余次数更新策略
    //0:系统自动处理 1:迭代1次更新 2:迭代完成更新
    //3:轮数1次更新 4:轮数完成更新
    //候选子句文字策略
    static INT32  candLiteral;  //候选子句文字策略
    //0:归结次数>稳定度 1:无(由原始顺序为准) 2:稳定度>归结次数
    static INT32  candLiteralDeductTimes;  //候选子句归结次数策略
    //0:由低到高 1:无(由输入顺序为准) 2:由高到低
    static INT32  candLiteralSteady;  //候选子句稳定度策略
    //0:由高到低 1:无(由原始顺序为准) 2:由低到高
    //R策略  
     static INT32 R_MAX_NUM; //子句最大文字数限制-不超过256
     static INT32 R_MAX_NUM_TMP;
     static INT32 R_INIT_MAX_NUM;//记录最原始的最大文字数(原始子句集)
     
     static INT32 R_MAX_NUM_NOPAIR;
    //R文字数大小
    static INT32 R_MAX_FUNCLAYER; //最大函数嵌套层限制-不超过256
    static INT32 R_MAX_FUNCLAYER_TMP; 
    static INT32 R_INIT_MAX_FUNCLAYER;//记录最原始的最大函数嵌套层
    static UINT8 goalDeepth;//目标子句简化距离
    //R函数嵌套层
    static INT32 R_Weight;//R权重大小
    //为-1时，系统自动处理；为大于0时设置值有效；
    //中间归结式生成
    static int midNum;  //Liu 控制每一次遍历候选子句集时剩余文字数
    static int  midR;//中间归结式生成
    static int litRundent;//R文字冗余处理
    //true 中间归结式生成 false 中间归结式不生成
    //宽深策略
     static INT32 widthDeep;  //宽深策略
     //0:深度优先 1:宽深结合 2:宽度优先
     //演绎深度策略
     static INT32 deductDeep;  //演绎深度策略
     static INT32 deducWidth;//演绎宽度策略
     //为-1时，系统自动处理；为大于0时设置值有效；
     //迭代次数
     static INT32 iterTimes;//迭代次数
     //为-1时，系统自动处理；为大于0时设置值有效；
     //迭代轮数
     static INT32 iterRing;//迭代轮数
     //为-1时，系统自动处理；为大于0时设置值有效；
     //时间限制
     static double timeForceLimit;
     static double readPreTime;
     static double firstTimeLimit;  //时间限制
     static double timeLimit;  //时间限制
     static double timeLimitStrategies;
     //时间限制 单位:分钟
     //内存限制
     static INT32 memLimit;  //内存限制
     static vector<UINT32> goalClaId;//存放目标子句ID
     static int singleGoalCount;//保存单元子句目标子句的个数
     //内存限制 单位:M
     //中间归结式冗余判断
     static bool midRJudge;//中间归结式冗余判断
     //true 中间归结式冗余判断 false 中间归结式冗余不判断
     static int funcFixDeepth;//综合函数复杂度
     static int funcFixDeepthLit;//文字函数复杂度
     static int funcOrgFixDeepthMax;//原始子句集子句综合函数复杂度最大值
     static int funcOrgFixDeepthLessMax;//原始子句集子句综合函数复杂度次最大值
     //后面增加的策略
     static int unitSortRule;//单元子句排序规则
     static int claFuncComp;//子句综合函数复杂度规则
     static int unitClaUpdate;//单元子句更新方式
     static bool noUnitRes;//是否允许非单元子句归结
     static bool noUnitSimplify;//判断非单元子句是否约简
     
     static bool divideTri; //是否拆分三角形输出
     
     static bool Rsmall; //R  原始子句文字最大数
     static bool RFsmall; //R  原始子句层数最大数
     static bool RRes;//是否允许R因子归结
     static bool delRecord;//是否删除未判定记录
     
     static bool reUseClause;
     static bool genLitClause;
     static int strategyMode;
     static int strategyModeTptp;
     static int noUintCla;
     static int deductMode;
     static bool factorRes;
     static bool eqnRes;
     static bool delPureCla;
     static bool goalCla;
     static bool singleUseUintCla;
     static bool useSaturate;
     static int termRewriting;
     static int termRewritingSize;
     static int deduceDepth;
     static int claReUseTimes;
     static bool useCpUintCla;
     static int claReUseTimesTmp;
     static UINT8 lockType;
     static UINT8 useCombinedSys ; 
     static UINT8 useCombinedSysMethod;
     static UINT8 combinedRMode;
     static UINT8 equalityUsedFrq;
     static UINT8 preprocess;
     static bool useRandrom;
     static bool termReRedund;//项代换检查冗余
     static bool equality;
     static double firstRunTime;
     static double TotalRunTime;    //20210520 结合E的系统总时间
     static bool orForCompition;
     static int problemDiv;
     static int cseRunMode;
     static int firstCseRunMode; //20210601 主函数设置的三角形算法模式
     static bool findStr;
     static double distriTime;
     static double divideTime;   //20210615
     static UINT64 compOutputId;
     static clock_t start;
     static double parseTime; //Liu 20210526 
     static double preTime;  //Liu 20210526
     static bool combineE;  //20210521 是否结合E（新的三段完全在C++代码中运行）
     static bool secondRunE;  //20210526 是否第二次调用E
    static int axiomsNum;   //20210601 原始子句集中等词公理的数量
    static int maxOriClauseId;  //20210601 原始子句集最大的子句ID   
    static string proField;    //20210608 
    static bool isInteraction;  //20210613
    static int cseMode; //20210616
    //////////////////////////////////////////////////////////////////////////
    //方法
    //////////////////////////////////////////////////////////////////////////

    //static void LoadStrategyXML(TiXmlDocument *pDoc, string directory);
    static void IniStrategy();
    //static void LoadClassSetXML(TiXmlDocument *pDoc, string directory);
    static void IniFileAndPathInfo(char*str, INT32 StartId);
private:

};

#endif /* STRATEGYPARAM_H */

