/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   SocketOp.h
 * Author: sjg
 *
 * Created on 2017年2月25日, 上午10:03
 */

#ifndef SOCKETOP_H
#define SOCKETOP_H
#include <sys/types.h>  
#include <sys/socket.h>  
#include <stdio.h>  
#include <netinet/in.h>  
#include <arpa/inet.h>  
#include <unistd.h>  
#include <stdlib.h>  
#include <string.h> 
#include "../basic/dataTypeDef.h"
#include "../basic/globalFunc.h"
class SocketOp {
public:
    static int sockfd;

    static bool CreateConect() {
        int len;
        struct sockaddr_in address;
        int result;  
        sockfd = socket(AF_INET,SOCK_STREAM,0);  
        address.sin_family = AF_INET;  
        address.sin_addr.s_addr = INADDR_ANY;  
        address.sin_port = htons(5678);  
        len = sizeof(address);  
        result = connect(sockfd,(struct sockaddr *)&address,len);  
        if(result == -1) {  
            perror("oops:client\n");  
            exit(1);  
        }  
    }

    static bool ClientMessage(const string& msg) 
    {
        char* str = const_cast<char*> (msg.c_str());
        //发送命令
        char sendData[4096];
        strcpy(sendData, str);
        INT32 len = strlen(sendData);  
        sendData[len] = '\0';  
        write(sockfd,sendData,len+1);  
        return true;
    }

    static void CloseSocket() {
        close(sockfd);
    }
    SocketOp();
    SocketOp(const SocketOp& orig);
    virtual ~SocketOp();
private:

};

#endif /* SOCKETOP_H */

