/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

#include <cstdlib>
#include "../fileOp/FileOp.h"
#include "../basic/InitFunction.h"
#include "cprover.h"
#include "../dataStructure/Formula.h"
#include "Prover.h"
#include "../basic/dataTypeDef.h"
#include "../basic//globalFunc.h"
#include "../network/SocketOp.h"
#include "../lib/chooseMode.h"
using namespace std;
class funcAddGreater{
public:
    bool operator()(const funcAdd* term1, const funcAdd* term2)
    {
        return term1->func < term2->func;
    }
};
class literalAddGreater{
public:
    bool operator()(const literalAdd* term1, const literalAdd* term2)
    {
        return term1->literal < term2->literal;
    }
};
void findFuncEquality(char* &sym,vector<funcAdd*> &funcAddEquality){
    funcAdd *funcSym = new funcAdd();
    funcSym->func = "";
    funcSym->suffix = 1;
    int iBracketNum = 0;
    while (*sym != '(') {
        funcSym->func += *sym;
        ++sym;
    }
    ++iBracketNum;
    while (iBracketNum > 0) {
        if (*sym == 'f') {
            findFuncEquality(sym, funcAddEquality);
        }
        else if (*sym == ',') {
            ++(funcSym->suffix); 
        }
        else if (*sym == ')') {
            --iBracketNum;
            if (iBracketNum == 0)
                break;
        }
        if(iBracketNum == 0){
            break;
        }
        ++sym;
    }
    funcAddEquality.push_back(funcSym);
}
//generated equality, according clause stream find the relation
void findEquality(char* &sym,vector<funcAdd*> &funcAddEquality,vector<literalAdd*> &LiteralAddEquality){
    while(1){
        if(*sym == 'p'){//find the needed add_equality 
            literalAdd *literalSym = new literalAdd();
            literalSym->literal = "";
            literalSym->suffix = 1;
            int iBracketNum = 0;
            bool proposition = false;
            bool runOneTime = true;
            while(*sym != '('){
                if(*sym == ' '){
                    ++sym;
                    continue;
                }
                if((*sym == '|') || (*sym == ')')){//especial case:( p1301 | p211(c1302) | p622(c2,c1303) | f54(c1304) != c1303 )). how to deal with?
                    literalSym->suffix = 1;
                    proposition = true;
                    break;
                }
                literalSym->literal += *sym; 
                ++sym;
                if(((*sym< '0')||(*sym >'9')) && runOneTime){//next sys of predicate term is not number 
                    proposition = true;
                    runOneTime = false;
                    break;
                }
                else if(((*sym >= '0') && (*sym <= '9'))&& runOneTime){
                    runOneTime = false;
                }
                
            }
            if(proposition){
                LiteralAddEquality.push_back(literalSym);
                continue;
            }
            ++iBracketNum;
            while(iBracketNum > 0){
                if(*sym == 'f'){
                    findFuncEquality(sym,funcAddEquality);
                }
                else if(*sym == ','){
                    ++(literalSym->suffix);
                }
                else if(*sym == ')'){
                    --iBracketNum;
                    if(iBracketNum == 0)
                        break;
                }
                ++sym;
            }
            LiteralAddEquality.push_back(literalSym);
        }
        if(*sym == 'f'){
            findFuncEquality(sym,funcAddEquality);
        }
        if(*sym == '.')
            break;
        ++sym;
    }
}
//generated equality term
string getTerm(int suffix, int size, int timeFlag){
    string res = "";
    vector<char> leftTerm;
    vector<char> rightTerm;
    for(int i=0; i<= size; ++i){
        if(i == 1)
            continue;
        leftTerm.push_back(i+'A');//get original term sort
    }
    for(int i=0; i<= size; ++i){
        if(i == 0)
            continue;
        rightTerm.push_back(i+'A');
    }
    for(int i=0; i<suffix; ++i){
        swap(leftTerm[i],leftTerm[i+1]);
        swap(rightTerm[i],rightTerm[i+1]);
    }
    if(timeFlag == 0){
        if(leftTerm.size()!=0){
            res += "(";
            for(int i=0;i<leftTerm.size();++i){
                res += leftTerm[i];
                if(i<leftTerm.size()-1){
                    res += ",";
                }
            }
            res += ")";
        }
        vector<char>().swap(leftTerm);
        vector<char>().swap(rightTerm);
        return res;
    }
    else if(timeFlag == 1){
      if(rightTerm.size()!=0){
            res += "(";
            for(int i=0;i<rightTerm.size();++i){
                res += rightTerm[i];
                if(i<rightTerm.size()-1){
                    res += ",";
                }
            }
            res += ")";
        }
        vector<char>().swap(leftTerm);
        vector<char>().swap(rightTerm);
        return res;  
    }
    vector<char>().swap(leftTerm);
    vector<char>().swap(rightTerm);
    return res;  
}
void addFunc(ofstream &ofInfoStream,funcAdd* funcSym){
    for(int i=0; i< funcSym->suffix; ++i){
        ofInfoStream << "cnf(" + funcSym->func + "_substitution_" + to_string(i+1) +",axiom," << endl;
        ofInfoStream << "    ( A != B | " + funcSym->func +getTerm(i,funcSym->suffix,0)+"= " + funcSym->func + getTerm(i,funcSym->suffix,1)+" ))." << endl;
        ofInfoStream << endl;
        StrategyParam::axiomsNum++;
    }
}
void addLiteral(ofstream &ofInfoStream,literalAdd* literalSym){
    for(int i=0; i< literalSym->suffix; ++i){
        ofInfoStream << "cnf(" + literalSym->literal + "_substitution_" + to_string(i+1) +",axiom," << endl;
        ofInfoStream << "    ( A != B | ~ " + literalSym->literal +getTerm(i,literalSym->suffix,0)+" | " + literalSym->literal + getTerm(i,literalSym->suffix,1)+" ))." << endl;
        ofInfoStream << endl;
        StrategyParam::axiomsNum++;
    }
}

//count time
double timeCount(clock_t initTime){
    clock_t endNoPair = clock();
    double time_sNoPair = (double) (endNoPair - initTime) / (double) CLOCKS_PER_SEC;
    return time_sNoPair;
}

bool OnlyRunEprover(double& executeTime) {
    bool proofFound = false;
    //E输出文件
    FileOp::OnlyRunEOutputFile = FileOp::workSpace + "/" + FileOp::judgeOriginalFileName + ".out";
    
    clock_t endTime = clock();
    StrategyParam::parseTime = (double)(endTime - StrategyParam::start) / CLOCKS_PER_SEC;  
    
    double runETime = StrategyParam::TotalRunTime - StrategyParam::parseTime - 1;
    string cmdRunE = "timeout " + to_string((int)runETime) + " " + FileOp::appPath + "/finalRunE/eprover --delete-bad-limit=2000000000 --definitional-cnf=24 -s --print-statistics -R --print-version --proof-object --auto-schedule --cpu-limit="
            + to_string((int)runETime) + " " + FileOp::judgeOriginalFileFullName + " >> " + FileOp::OnlyRunEOutputFile;
    //cout << "cmdRunE: " << cmdRunE << endl;
    int resRunE = system(const_cast<char*> (cmdRunE.c_str())); 
    //打印信息
    string outMsg = "";
    proofFound = FileOp::OutputForCompetition(FileOp::OnlyRunEOutputFile, executeTime, outMsg);
    
    //若E判定成功，则创建输出文件夹,并将输出文件benchmark.out移动到该文件夹中
    if (proofFound) {
        cout << outMsg;
        string outFileName = FileOp::workSpace + "/" + FileOp::judgeOriginalFileName;
        FileOp::isExistDir(outFileName);
        //将E的输出文件.out移到刚创建的输出文件夹
        string cmdMove = "mv " + FileOp::OnlyRunEOutputFile + " " + outFileName;
        int resMove = system(const_cast<char*> (cmdMove.c_str()));
    }
    else //否则删除E输出文件.out
        remove(FileOp::OnlyRunEOutputFile.c_str());
    
    return proofFound;
}

bool RunEprover(const string& tptpShortFile, double& executeTime) {
    bool proofFound = false;
    FileOp::eOutputFile = FileOp::eOutputFile = FileOp::workSpace + "/" + FileOp::judgeOriginalFileName + ".first_out";
    
    //运行E
    string cmdRunE = "";
    if (StrategyParam::isInteraction) {
        cmdRunE = "timeout " + to_string((int)StrategyParam::firstRunTime) + " " + FileOp::appPath + "/eprover --delete-bad-limit=2000000000 --definitional-cnf=24 -s --full-deriv --tstp-format --print-statistics -R --print-version --proof-object --auto-schedule --cpu-limit="
                + to_string((int)StrategyParam::firstRunTime) + " " + tptpShortFile + " >> " + FileOp::eOutputFile;
    }
    else {
        cmdRunE = "timeout " + to_string((int)StrategyParam::firstRunTime) + " " + FileOp::appPath + "/finalRunE/eprover --delete-bad-limit=2000000000 --definitional-cnf=24 -s --print-statistics -R --print-version --proof-object --auto-schedule --cpu-limit="
            + to_string((int)StrategyParam::firstRunTime) + " " + FileOp::judgeOriginalFileFullName + " >> " + FileOp::eOutputFile;
    }   
    //cout << cmdRunE << endl;
    clock_t endTime = clock();
    StrategyParam::parseTime = (double)(endTime - StrategyParam::start) / CLOCKS_PER_SEC;
    
    int resRunE = system(const_cast<char*> (cmdRunE.c_str())); 
    //打印信息
    string outMsg = "";
    proofFound = FileOp::OutputForCompetition(FileOp::eOutputFile, executeTime, outMsg);
    //若E判定成功，则创建输出文件夹,并将输出文件.out移动到该文件夹中
    if (proofFound) {
        cout << outMsg << endl;
        string outFileName = FileOp::workSpace + "/" + FileOp::judgeOriginalFileName;
        FileOp::isExistDir(outFileName);
        //将E的输出文件.first_out移到刚创建的输出文件夹
        string cmdMove = "mv " + FileOp::eOutputFile + " " + outFileName;
        int resMove = system(const_cast<char*> (cmdMove.c_str()));
    } 
    
    return proofFound;
} 

//将fof格式转成TPTP格式
//const string& convertedFile 为转换过后的文件
void ConvertFofToTptp(const string& convertedFile) {
    //转换时间设置
    double maxConvertCNFTime = 0.0;
    if (FileOp::runMode == 0)  //CSE系统
        maxConvertCNFTime = StrategyParam::timeForceLimit;
    else if (FileOp::runMode == 4)     //CSE_E系统
        maxConvertCNFTime = StrategyParam::TotalRunTime;
    //转换命令
    string cmd = "timeout "+ to_string(maxConvertCNFTime) + " " + FileOp::appPath + "/finalRunE/eprover --tstp-format --cnf "
            + FileOp::judgeOriginalFileFullName + "  >> " + convertedFile;
    //转换
    int res4 = system(const_cast<char*> (cmd.c_str()));
}

//将cnf格式进行shorten
void ShortenCnfFile(const string& tptpFolder, const string& cnfFile, const string& logFile) {
    //转换时间设置
    double maxConvertShortTime = 0.0;
    if (FileOp::runMode == 0)  //CSE系统
        maxConvertShortTime = StrategyParam::timeForceLimit;
    else if (FileOp::runMode == 4)     //CSE_E系统
        maxConvertShortTime = StrategyParam::TotalRunTime;
    //转换命令
    string cmd = "timeout " + to_string(maxConvertShortTime) + " " + FileOp::appPath + "/tptp4X -tshorten -d " 
            + tptpFolder + " " + cnfFile + " >> " + logFile;
    //转换
    int res = system(const_cast<char*> (cmd.c_str())); 
}

//添加等词公理
//const string& tptpShortFile short后的文件; const string& tptpFolde ./dist/output/tptp文件夹
void addEqualityAxiom(const string& tptpShortFile, const string& tptpFolder) {
    string file = "";
    //1. 是否含有等词
    //判断是否含有等词，并将原始子句拷贝到benchmark.cnf文件中
    string strMsg = "";
    string strLine = "";
    bool addEqualityFlag = false;
    ifstream ifFolFileTptp(tptpShortFile);
    while (getline(ifFolFileTptp, strLine)) {
        TrimStr(strLine); //去除头尾空格
        if(strLine.find("=",0)!= -1){
           addEqualityFlag = true;
           //break;
        } 
        if (strLine == "")
            continue;
        strMsg += strLine;
        strMsg += "\n";
    }
    ifFolFileTptp.close();
      
    //2. 不含有等词 or 不处理等词，将short后文件改名
    if((!addEqualityFlag) || (!StrategyParam::equality)) {
        string nameLast = tptpFolder + "/" + FileOp::judgeOriginalFileName + "+short+noeq.tptp";
        string changeFileNameCmd = "mv " + tptpShortFile + " " + nameLast;  
        int res6 = system(const_cast<char*> (changeFileNameCmd.c_str()));
        file = nameLast;

        FileOp::AnalysisFileName(file);
        FileOp::PrintInfoForEprover(strMsg);  //将原始子句写入到.cnf中
    }
    else if(StrategyParam::equality){   //含有等词
        //add equality 添加等词
        vector<funcAdd*> funcAddEquality;
        funcAddEquality.reserve(16);
        vector<literalAdd*> LiteralAddEquality;
        LiteralAddEquality.reserve(16);
        //start parse
        ifstream ifFolFileShort(tptpShortFile);
        while(getline(ifFolFileShort, strLine)) {
            TrimStr(strLine); //去除头尾空格
            if(strLine.length() == 0 || strLine[0] == '%'|| strLine[0] == 'c') 
                continue; //空行和%--注释语句 不读取
            char* ch = const_cast<char*> (strLine.c_str()); 
            findEquality(ch,funcAddEquality,LiteralAddEquality);
        }
        ifFolFileShort.close();
        //unique
        if(funcAddEquality.size() != 0){
            for (size_t rInd = 0; rInd < funcAddEquality.size() - 1; ++rInd) {
                funcAdd* rA = funcAddEquality[rInd];
                for (size_t rIndB = rInd + 1; rIndB < funcAddEquality.size();) {
                    funcAdd* rB = funcAddEquality[rIndB];
                    if ((rA->func == rB ->func) && (rA->suffix == rB->suffix)) {
                        swap(funcAddEquality[rIndB], funcAddEquality[funcAddEquality.size() - 1]);
                        funcAddEquality.pop_back();
                    } else
                        ++rIndB;
                }
            }
        }
        if(LiteralAddEquality.size() != 0){
            for (size_t rInd = 0; rInd < LiteralAddEquality.size() - 1; ++rInd) {
                literalAdd* rA = LiteralAddEquality[rInd];
                for (size_t rIndB = rInd + 1; rIndB < LiteralAddEquality.size();) {
                    literalAdd* rB = LiteralAddEquality[rIndB];
                    if ((rA->literal == rB ->literal ) && (rA->suffix == rB->suffix)) {
                        swap(LiteralAddEquality[rIndB], LiteralAddEquality[LiteralAddEquality.size() - 1]);
                        LiteralAddEquality.pop_back();
                    } else
                        ++rIndB;
                }
            }
        }
        //generated equality  
        if (1) {
            ofstream ofInfoStreamOut(tptpShortFile, ios::app);
            ofInfoStreamOut << "cnf(reflexivity,axiom," << endl;
            ofInfoStreamOut << "    ( A = A ))." << endl;
            ofInfoStreamOut << endl;
            ofInfoStreamOut << "cnf(symmetry,axiom," << endl;
            ofInfoStreamOut << "    ( A != B | B = A ))." << endl;
            ofInfoStreamOut << endl;
            ofInfoStreamOut << "cnf(transitivity,axiom," << endl;
            ofInfoStreamOut << "    ( A != B | B != C | A = C ))." << endl;
            ofInfoStreamOut << endl;
            StrategyParam::axiomsNum = 3;   //等词公理数量加3
            if(funcAddEquality.size() != 0){
                for(int i=0; i<funcAddEquality.size(); ++i){
                    if(funcAddEquality[i]->suffix >= 23){//not add equilty 20190719
                        continue;
                    }
                    addFunc(ofInfoStreamOut,funcAddEquality[i]);
                    //ofInfoStreamOut << endl;
                }
            }
            if(LiteralAddEquality.size() != 0){
                for(int i=0; i<LiteralAddEquality.size(); ++i){
                    if(LiteralAddEquality[i]->suffix >= 23){//not add equilty 20190719
                        continue;
                    }
                    addLiteral(ofInfoStreamOut,LiteralAddEquality[i]);
                    //ofInfoStreamOut << endl;
                }
            }  
            //改名
            string nameLast = tptpFolder + "/" + FileOp::judgeOriginalFileName + "+short+eq_rstfp.tptp";
            string changeFileNameCmd = "mv " + tptpShortFile + " " + nameLast;  
            int res6 = system(const_cast<char*> (changeFileNameCmd.c_str()));

            file = nameLast;
            FileOp::AnalysisFileName(file); 
            FileOp::PrintInfoForEprover(strMsg);  //将原始子句写入到.cnf中
        }
        else {
            //generated equality
            string nameLast = tptpFolder + "/" + FileOp::judgeOriginalFileName + "+short+eq_rstfp.tptp";
            ifstream ifFolFileOut(tptpShortFile);
            ofstream ofInfoStreamOut(nameLast, ios::app);
            bool addE = true;
            while(getline(ifFolFileOut, strLine)) {
                if(strLine[0] == '%' || strLine[0] == '-'){
                    ofInfoStreamOut << strLine << endl;
                    continue;
                }
                //add equality
                if(addE){
                    ofInfoStreamOut << "cnf(reflexivity,axiom," << endl;
                    ofInfoStreamOut << "    ( A = A ))." << endl;
                    ofInfoStreamOut << endl;
                    ofInfoStreamOut << "cnf(symmetry,axiom," << endl;
                    ofInfoStreamOut << "    ( A != B | B = A ))." << endl;
                    ofInfoStreamOut << endl;
                    ofInfoStreamOut << "cnf(transitivity,axiom," << endl;
                    ofInfoStreamOut << "    ( A != B | B != C | A = C ))." << endl;
                    ofInfoStreamOut << endl;
                    StrategyParam::axiomsNum = 3;
                    if(funcAddEquality.size() != 0){
                        for(int i=0; i<funcAddEquality.size(); ++i){
                            if(funcAddEquality[i]->suffix >= 23){//not add equilty 20190719
                                continue;
                            }
                            addFunc(ofInfoStreamOut,funcAddEquality[i]);
                            //ofInfoStreamOut << endl;
                        }
                    }
                    if(LiteralAddEquality.size() != 0){
                        for(int i=0; i<LiteralAddEquality.size(); ++i){
                            if(LiteralAddEquality[i]->suffix >= 23){//not add equilty 20190719
                                continue;
                            }
                            addLiteral(ofInfoStreamOut,LiteralAddEquality[i]);
                            //ofInfoStreamOut << endl;
                        }
                    }
                    addE = false;
                }
                ofInfoStreamOut << strLine << endl;

            }
            ifFolFileOut.close();
            ofInfoStreamOut.close();
            funcAddEquality.clear();
            vector<funcAdd*>().swap(funcAddEquality);
            LiteralAddEquality.clear();
            vector<literalAdd*>().swap(LiteralAddEquality);
            remove(tptpShortFile.c_str());

            file = nameLast;
            FileOp::AnalysisFileName(file);  
            FileOp::PrintInfoForEprover(strMsg);  //将原始子句写入到.cnf中
        }
    }
}

int main(int argc, char** argv) {  
    StrategyParam::start = clock();//start time
//#define newTriDebug
#ifndef newTriDebug
    //竞赛版本下：runMode都为偶数，即都判定单问题；orCompetitionVersion都为1; theoremFormat格式都为fof格式，即为0
    //CSE有7个实际参数；CSE_E有9个实际参数
    string filePath = argv[1];   //得到问题的绝对路径
    string strategyMode = argv[2];  //策略模式：1，多策略；0，单策略
    string runMode = argv[3];   //0：CSE版本；4：结合E版本
    string orCompetitionVersion = argv[4];  //1：竞赛模式；0：机房模式
    string workspace = argv[5]; //工作路径
    string inferRule = argv[6]; //做矛盾体的算法版本 0-8
    string distriFirstTime = argv[7];   //矛盾体组合算法的时间分配参数
    //根据系统版本，设置系统运行时间
    string timeForce = "";
    string usedTime = "";
    string totalRunTime = "";
    if (runMode == "0") {   //CSE版本
        timeForce = argv[8];  //CSE运行时间
    }
    else if (runMode == "4") {  //结合E版本
        usedTime = argv[8];  //E第一段的运行时间
        timeForce = argv[9]; //CSE运行时间
        totalRunTime = argv[10];  //系统总的运行时间
    }
#else
    //string filePath = "/home/swjtu/Desktop/dist/problems/COM008+1.p";   //得到问题的绝对路径
    //string filePath = "/home/swjtu/Desktop/dist/problems/TOP048+1.p";   //得到问题的绝对路径
    string filePath = "/home/ars01/Desktop/dist/problems/AGT012+2.p";   //得到问题的绝对路径
    //string filePath = "/home/swjtu/Desktop/dist/problems/MED007+1.p";   //得到问题的绝对路径
    //string filePath = "/home/swjtu/Desktop/dist/problems/KRS251+1.p";   //得到问题的绝对路径
    string strategyMode = "1";  //策略模式：1，多策略；0，单策略
    string runMode = "4";   //0：CSE版本；4：结合E版本
    string orCompetitionVersion = "0";  //1：竞赛模式；0：机房模式
    string workspace = "/home/ars01/Desktop/dist"; //工作路径
    string inferRule = "7"; //做矛盾体的算法版本 0-8
    string distriFirstTime = "5";   //矛盾体组合算法的时间分配参数
    //根据系统版本，设置系统运行时间
    string timeForce = "";
    string usedTime = "";
    string totalRunTime = "";    
    if (runMode == "0") {   //CSE版本
        timeForce = "70";  //CSE运行时间
    }
    else if (runMode == "4") {  //结合E版本
        usedTime = "10";  //E第一段的运行时间
        timeForce = "10"; //CSE运行时间
        totalRunTime = "30";  //系统总的运行时间
    }  
#endif 
    StrategyParam::isInteraction = false;
    StrategyParam::equality = false;    // not add equality axioms
    bool convertFail = false;
    bool shortenFail = false;
    bool firstESuccess = false;
    
    FileOp::appPath = workspace;
    if (orCompetitionVersion == "1")
        StrategyParam::orForCompition = true;   //竞赛模式
    else
        StrategyParam::orForCompition = false;  //机房模式
    StrategyParam::problemDiv = 0;  //1： 判定不可满足性； 0： 判定可满足性问题
    FileOp::strategyMode = atoi(strategyMode.c_str());
    FileOp::runMode = atoi(runMode.c_str());
    
    //根据系统版本，设置系统运行时间
    //CSE组合版本时间分配参数设置
    StrategyParam::firstCseRunMode = atoi(inferRule.c_str());
    if (StrategyParam::firstCseRunMode == 2 || StrategyParam::firstCseRunMode == 3 || StrategyParam::firstCseRunMode == 8) //CSE为组合模式（时间分配）
        StrategyParam::distriTime = stod(distriFirstTime) / 60; 
    else
        StrategyParam::distriTime = 0;  
    //系统时间参数设置
    if (FileOp::runMode == 0) { //CSE系统
        StrategyParam::timeForceLimit = stod(timeForce);
    } 
    else if (FileOp::runMode == 4) {    //CSE_E系统
        StrategyParam::firstRunTime = stod(usedTime);
        StrategyParam::timeForceLimit = stod(timeForce);
        StrategyParam::TotalRunTime = stod(totalRunTime);
    }
    
    int tempMode = 0;
    if (FileOp::runMode == 4) {
        if (StrategyParam::TotalRunTime == 360) {
            tempMode = chooseMode::ReadOriProblem360(filePath, StrategyParam::firstRunTime, StrategyParam::timeForceLimit);
        }
        else if (StrategyParam::TotalRunTime > 240 && StrategyParam::TotalRunTime <= 300) {
            tempMode = chooseMode::ReadOriProblem300(filePath, StrategyParam::firstRunTime, StrategyParam::timeForceLimit);
        }
        else if (StrategyParam::TotalRunTime > 180 && StrategyParam::TotalRunTime <= 240) {
            tempMode = chooseMode::ReadOriProblem240(filePath, StrategyParam::firstRunTime, StrategyParam::timeForceLimit);
        }
        else if (StrategyParam::TotalRunTime > 120 && StrategyParam::TotalRunTime <= 180) {
            tempMode = chooseMode::ReadOriProblem180(filePath, StrategyParam::firstRunTime, StrategyParam::timeForceLimit);
        }
        else if (StrategyParam::TotalRunTime == 120) {
            tempMode = chooseMode::ReadOriProblem120(filePath, StrategyParam::firstRunTime, StrategyParam::timeForceLimit);
        }
        else 
            tempMode = 2;
        
        if (tempMode == 1) {
            StrategyParam::firstRunTime = StrategyParam::TotalRunTime;
            StrategyParam::timeForceLimit = 0;
        }
        else if (tempMode == 3) {
            StrategyParam::firstRunTime = 0;
            if (StrategyParam::TotalRunTime == 360)
                StrategyParam::timeForceLimit = 60;
            else if (StrategyParam::TotalRunTime > 240 && StrategyParam::TotalRunTime <= 300) 
                StrategyParam::timeForceLimit = 50;
            else if (StrategyParam::TotalRunTime > 180 && StrategyParam::TotalRunTime <= 240)
                StrategyParam::timeForceLimit = 40;
            else if (StrategyParam::TotalRunTime > 120 && StrategyParam::TotalRunTime <= 180)
                StrategyParam::timeForceLimit = 30;
            else if (StrategyParam::TotalRunTime == 120)
                StrategyParam::timeForceLimit = 20;
        }
    }

    //设置格式转换的timeout时间
    double maxConvertCNFTime = 0.0;
    double maxConvertShortTime = 0.0;
    if (FileOp::runMode == 0) { //CSE系统
        maxConvertCNFTime = StrategyParam::timeForceLimit;
        maxConvertShortTime = StrategyParam::timeForceLimit;
    } 
    else if (FileOp::runMode == 4) {    //CSE_E系统
        maxConvertCNFTime = StrategyParam::TotalRunTime;
        maxConvertShortTime = StrategyParam::TotalRunTime;
    }
    
    //初始化相关路径信息
    FileOp::workSpace = workspace + "/output";  // 保存 ./dist/output
    //创建./dist/output文件夹
    bool workspaceExist = FileOp::isExistDir(FileOp::workSpace);  // ./dist/output
    
    //创建./dist/output/unsat文件夹
//    string saveWorkPath = FileOp::workSpace + "/unsat";   // ./dist/output/unsat
//    FileOp::isExistDir(saveWorkPath);
    
    //记录HOME变量和strategy文件夹路径（./dist/strategy）
    FileOp::getTopPath(true); 
    
    //记录./dist/output/tptp文件夹路径和./dist/output/tptp/log.txt文件路径
    string tptpFolder = FileOp::workSpace + "/tptp"; //记录./dist/output/tptp文件夹路径
    string logFile = FileOp::workSpace + "/tptp/log.txt";   //记录./dist/output/tptp/log.txt文件路径
    //创建./dist/output/tptp文件夹，并若存在，则删除文件夹中所有文件
    bool res = FileOp::isExistDir(tptpFolder);
    if (res) 
        FileOp::delAllFilesComplete(tptpFolder);
    if (StrategyParam::orForCompition == false)
        FileOp::clearRes(); //清空proofRes文件，并重新创建
    
    //初始化问题名称并保存
    FileOp::judgeOriginalFileFullName = filePath;   //保存原始问题的绝对路径 ./dist/problems/benchmark.p
    
    size_t pos = filePath.find_last_of('/');
    string fileName = filePath.substr(pos + 1);//判断文件名
    size_t posEnd = fileName.find_last_of('.');
    FileOp::judgeOriginalFileName = fileName.substr(0,posEnd);  //保存原始问题名称, 即 benchmark
    
    string suffix = fileName.substr(posEnd + 1);    //判断文件的格式
    
    cout << "start to proof: " << FileOp::judgeOriginalFileName << endl;
    
    if (tempMode == 1 && FileOp::runMode == 4) {
        //直接使用E判定问题
        double executeTime = 0.0;
        if (OnlyRunEprover(executeTime)) {  //E判定成功
            if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                string msg = to_string(executeTime);
                FileOp::PrintStatisticsMsg(msg);
            }
        }
        else {  //E判定失败
            if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                string msg = "TMO‑Non";
                FileOp::PrintStatisticsMsg(msg);
            }
            cout << "TMO‑Non" << endl;
        } 
        return 0;
    }    
    else if (tempMode == 2 && FileOp::runMode == 4 && StrategyParam::isInteraction == false) {   //E->CSE->E
        //若为CSE_E系统，第一次运行E
        if (FileOp::runMode == 4 && StrategyParam::firstRunTime != 0) {
            double executeTime = 0.0;
            if (RunEprover(FileOp::judgeOriginalFileFullName, executeTime)) {  //E判定成功
                if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                    string msg = to_string(executeTime);
                    FileOp::PrintStatisticsMsg(msg);
                }
                //成功后删除tptp文件，即./dist/output/tptp/benchmark.tptp
                //remove(tptpShortFile.c_str());
                firstESuccess = true;
            }
            StrategyParam::start = clock();
            //删除log.txt文件
            //remove(logFile.c_str());
        }
        //若E判定成功，则推出系统
        if (firstESuccess)
            return 0;        
    }
    
    //格式处理
    if (suffix == "p" || suffix == "P"|| suffix == "tptp"|| suffix == "TPTP") {
        //后缀.p与.P为fof格式（即TPTP上原始问题格式），需要利用E转成tptp格式（即CNF格式）
        string cnfFile = "";    //记录cnf格式的文件路径
        if (suffix == "p" || suffix == "P") {
            cnfFile = FileOp::workSpace + "/" + FileOp::judgeOriginalFileName + ".p";   //保存./dist/output/benchmark.p
            ConvertFofToTptp(cnfFile);
        }
        else
            cnfFile = filePath; //problems中原始问题本身就为cnf格式
        
        //检查转换是否成功
        if (FileOp::isFileEmpty(cnfFile)) { //为空文件
            if (FileOp::runMode == 0) { //CSE系统
                if (StrategyParam::orForCompition == false) {
                    cout << "CNF convert failed!" << endl;
                    string msg = "UNK‑Non";
                    FileOp::PrintStatisticsMsg(msg);
                }
                cout << "UNK‑Non" << endl;
            }
            else if (FileOp::runMode == 4) {    //CSE_E系统
                //直接使用E判定问题
                double executeTime = 0.0;
                if (OnlyRunEprover(executeTime)) {  //E判定成功
                    if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                        string msg = to_string(executeTime);
                        FileOp::PrintStatisticsMsg(msg);
                    }
                }
                else {  //E判定失败
                    if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                        string msg = "TMO‑Non";
                        FileOp::PrintStatisticsMsg(msg);
                    }
                    cout << "TMO‑Non" << endl;
                }
            }
            //删除cnf文件，即./dist/output/benchmark.p
            remove(cnfFile.c_str());
            convertFail = true;
        }
        //若cnf格式转换失败，则退出系统
        if (convertFail) 
            return 0;
        
        //后缀.tptp与.TPTP为tptp格式（即CNF格式），需要利用TPTP4X进行shorten
        ShortenCnfFile(tptpFolder, cnfFile, logFile);
        remove(cnfFile.c_str());    //删除cnf格式文件
        
        //记录shorten后文件
        string tptpShortFile = tptpFolder + "/" + FileOp::judgeOriginalFileName + ".tptp";
        
        //检查shorten是否成功
        if (access(tptpShortFile.c_str(), F_OK) == 0) {
            if (FileOp::isFileEmpty(cnfFile)) { //为空文件
                if (FileOp::runMode == 0) { //CSE系统
                    if (StrategyParam::orForCompition == false) {
                        cout << "Short failed!" << endl;
                        string msg = "UNK‑Non";
                        FileOp::PrintStatisticsMsg(msg);
                    }
                    cout << "UNK‑Non" << endl;
                }
                else if (FileOp::runMode == 4) {    //CSE_E系统
                    //直接使用E判定问题
                    double executeTime = 0.0;
                    if (OnlyRunEprover(executeTime)) {  //E判定成功
                        if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                            string msg = to_string(executeTime);
                            FileOp::PrintStatisticsMsg(msg);
                        }
                    }
                    else {  //E判定失败
                        if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                            string msg = "TMO‑Non";
                            FileOp::PrintStatisticsMsg(msg);
                        }
                        cout << "TMO‑Non" << endl;
                    }
                }
                //删除tptp文件，即./dist/output/tptp/benchmark.tptp 和log.txt文件
//                remove(tptpShortFile.c_str());
//                remove(logFile.c_str());
                shortenFail = true;
            }   
        }
        else {
            if (FileOp::runMode == 0) { //CSE系统
                if (StrategyParam::orForCompition == false) {
                    cout << "Short failed!" << endl;
                    string msg = "UNK‑Non";
                    FileOp::PrintStatisticsMsg(msg);
                }
                cout << "UNK‑Non" << endl;
            }
            else if (FileOp::runMode == 4) {    //CSE_E系统
                //直接使用E判定问题
                double executeTime = 0.0;
                if (OnlyRunEprover(executeTime)) {  //E判定成功
                    if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                        string msg = to_string(executeTime);
                        FileOp::PrintStatisticsMsg(msg);
                    }
                }
                else {  //E判定失败
                    if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                        string msg = "TMO‑Non";
                        FileOp::PrintStatisticsMsg(msg);
                    }
                    cout << "TMO‑Non" << endl;
                }
            } 
//            remove(logFile.c_str());
            shortenFail = true;
        }
        //若shorten失败，则退出系统
        if (shortenFail) 
            return 0; 
      
        //若为CSE_E系统，第一次运行E
        if (FileOp::runMode == 4 && StrategyParam::firstRunTime != 0 && StrategyParam::isInteraction) {
            double executeTime = 0.0;
            if (RunEprover(tptpShortFile, executeTime)) {  //E判定成功
                if (StrategyParam::orForCompition == false) {   //机房模式 在proofStatistics.txt打印信息
                    string msg = to_string(executeTime);
                    FileOp::PrintStatisticsMsg(msg);
                }
                //成功后删除tptp文件，即./dist/output/tptp/benchmark.tptp
                //remove(tptpShortFile.c_str());
                firstESuccess = true;
            }
            StrategyParam::start = clock();
            //删除log.txt文件
            //remove(logFile.c_str());
        }
        //若E判定成功，则推出系统
        if (firstESuccess)
            return 0;
       
        //添加等词公理
        addEqualityAxiom(tptpShortFile, tptpFolder);       
    }

    //20210521 将第一段E执行后的输出文件.first_out移到问题输出文件夹
    if (FileOp::runMode == 4 && StrategyParam::firstRunTime != 0) {
        string cmdMove = "mv " + FileOp::eOutputFile + " " + FileOp::g_OutputPath;
        int resMove = system(const_cast<char*> (cmdMove.c_str())); 
        FileOp::eOutputFile = FileOp::g_OutputPath + "/" + FileOp::judgeOriginalFileName + ".first_out";
    }        

    //读取文件预处理，生成预处理文件
    if (1) {           
        pid_t pid;
        pid = fork();
        if(pid == 0) {
            Formula fol;
            INT32 startId = InitFunction::StrToAny("-1");
            if (startId == -1)//预处理
                cprover::PreProcess(fol);
            string sPreprocess = fol.GetFormulaInfo();
            sPreprocess += "\n" + fol.ToString(false);
            FileOp::WritePreFile(sPreprocess);
//            //for competition
//            if (FileOp::runMode == 4) {   //对于结合E系统，将预处理过后的子句输出到.res
//                string str = "";
//                str += fol.competInitClauseSet();
//                FileOp::prinfPreResForE(str); //输出所有的子句到.res
//            }
            fol.DelSet();
            exit(0);
        }
        else if(pid >0)
        {
            waitpid(pid,NULL,0);
        }    
    }  

    //进行问题判定
    RESULT s;
    if(StrategyParam::orForCompition){
        s = Prover::prover();
    }
    else {
        pid_t child;
        child = fork();
        if (child == 0) {
            s = Prover::prover();
            exit(0);
        } 
        else if (child > 0) {
            waitpid(child, NULL, 0);
        }
    } 
    
    if (s == READERR) { 
        if (FileOp::runMode == 0) {
            cout << "formula set is empty: READERR" << endl;
            if (StrategyParam::orForCompition == false) {
                string msg = "UNK‑Non";
                FileOp::PrintStatisticsMsg(msg);
            } 
            //删除相关文件和文件夹
            FileOp::delAllFilesComplete(FileOp::g_OutputPath);
            rmdir(FileOp::g_OutputPath.c_str());             
        }
        else if (FileOp::runMode == 4) {
            //运行E
            string cnfFile = FileOp::judgeOriginalFileFullName;
            double realRunTime = 0.0;
            double secondETime = StrategyParam::TotalRunTime - StrategyParam::parseTime - StrategyParam::firstRunTime - StrategyParam::preTime;
            
            if (FileOp::SecondRunEprover(secondETime, cnfFile)) {   //E判定成功
                string outMsg = "";
                bool isProof = false;
                //首先打印版本信息
                outMsg += "% Version  : CSE_E---1.4\n";
                outMsg += "% Problem  : " + FileOp::judgeOriginalFileName + ".p\n";
                //读取输出文件
                ifstream ifOutputFile(FileOp::eSecondOutputFile);

                string strLine = "";
                while (getline(ifOutputFile, strLine)) {
                    if (strLine.find("#", 0) != string::npos) {
                        if (strLine.find("Proof found!", 0) != string::npos) {
                            outMsg += "% Proof found\n";
                            isProof = true;
                        }
                        else if (isProof && strLine.find("SZS status Theorem", 0) != string::npos) { 
                            outMsg += "% SZS status Theorem for " + FileOp::judgeOriginalFileName + ".p\n";
                        }
                        else if (isProof && strLine.find("SZS output start CNFRefutation", 0) != string::npos) {
                            outMsg += "% SZS output start Proof\n";
                        }
                        else if (isProof && strLine.find("SZS output end CNFRefutation", 0) != string::npos) {
                            outMsg += "% SZS output end Proof\n";
                        }
                        else if (isProof && strLine.find("Total time", 0) != string::npos) {
                            //记录E耗费时间
                            int beginPos = strLine.find(":");
                            int endPos = strLine.find("s");
                            string tempTime = strLine.substr(beginPos + 2, (endPos - 1) - (beginPos + 2));
                            realRunTime = stod(tempTime);
                            //计算系统总时间
                            realRunTime += StrategyParam::parseTime + StrategyParam::firstRunTime + StrategyParam::preTime;
                            //打印时间信息
                            //cout << "% Total time : " << executeTime << " s" << endl;
                            outMsg += "% Total time : " + to_string(realRunTime) + " s\n";
                            //fout << "% Total time : " << executeTime << " s" << endl;
                        }
                    }
                    else if (isProof) {
                        //cout << strLine << endl;
                        outMsg += strLine + "\n";
                        //fout << strLine << endl;
                    } 
                }
                ifOutputFile.close();            
                //打印统计信息
                if (isProof && StrategyParam::orForCompition == false) {
                    string msg = to_string(realRunTime);
                    FileOp::PrintStatisticsMsg(msg);
                }
                else if (isProof == false && StrategyParam::orForCompition == false) {
                    string msg = "TMO‑Non";
                    FileOp::PrintStatisticsMsg(msg);
                }
            }
            else {
                cout << "CSE_E is exited by timeout" << endl;
                if (StrategyParam::orForCompition == false) {
                    string msg = "TMO‑Non";
                    FileOp::PrintStatisticsMsg(msg);
                }   
                FileOp::delAllFilesComplete(FileOp::g_OutputPath);
                rmdir(FileOp::g_OutputPath.c_str());
            }            
        }
    }
    
    return 0;
}
